/* TODO:
 * overloadare ricezione_socket() per stoppare la ricezione del buffer al
 * riconoscimento di un carattere di fine ricezione!
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <stream.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/param.h>

class Connection
{
private:
  int num_porta;
  int id_socket;
  int id_accept;
  unsigned int buffersize;
  struct hostent *phost;
  struct timeval timeout;
  struct sockaddr_in nome_socket;
  struct sockaddr_in nome_accept;
  unsigned int dim_nome_accept;
  
public:
  Connection(int porta);
  
  int accetta_socket();
  void chiudi_socket();
  void set_buffersize(unsigned int size);

  Connection & operator << (const char *buf);
  Connection & operator >> (char *buf);
  
  ~Connection();
};

Connection::Connection(int porta) {
  num_porta = porta;
  int one = 1;
  
  if((id_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_IP)) < 0)
    perror("Unable to open tcp/ip socket");
  
  if(setsockopt(id_socket, SOL_SOCKET, SO_REUSEADDR, &one, sizeof(int)) < 0)
    perror("Unable to set socket parameters");
  
  memset(&nome_socket,0,sizeof(struct sockaddr_in));
  memset(&nome_accept,0,sizeof(struct sockaddr_in));
  
  nome_socket.sin_family = AF_INET;
  nome_socket.sin_port = htons(num_porta);
  nome_socket.sin_addr.s_addr = htonl(INADDR_ANY);
  
  id_accept = -2;
  
  if(bind(id_socket, (struct sockaddr *) &nome_socket, sizeof(nome_socket))==-1)
    perror("Unable to bind tcp/ip connection");
  
  if(listen(id_socket, 5)==-1)
    perror("Cannot listen over tcp/ip");
}

int Connection::accetta_socket() {
  dim_nome_accept = sizeof(struct sockaddr_in);
  id_accept = accept(id_socket, (struct sockaddr *) &nome_accept, &dim_nome_accept);
  return id_accept;
}

void Connection::chiudi_socket() {
  close(id_accept);
  id_accept = -2;
}

void Connection::set_buffersize(unsigned int size) {
  buffersize = size;
}

Connection & Connection::operator << (const char *buf) {
  send(id_accept, buf, strlen(buf+1), 0);

  return *this;
}

Connection & Connection::operator >> (char *buf) {
  int c;
  char *p;

  c = recv(id_accept, buf, buffersize, 0x0);
  /* make it terminate with a \0 */
  if(c<buffersize)
    buf[c] = '\0';
  else
    /* we have a buffer overflow here */
    fprintf(stderr,"SOCKET_SERVER: network connected buffer overflow\n");
  return *this;
}

Connection::~Connection() {
  if(id_accept > -1)
    chiudi_socket();
}
